#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include "../server/config.h"
#include "../server/database.h"

char *classes[] =
{"no_access", "read_only", "read_write", "moderator", "no_class"};

bb_rid room;
jmp_buf Main_loop_env;

signal_t sigsegv()
{
    fprintf(stderr, "Died on %d\n", room++);
    fflush(stderr);
    signal(SIGSEGV, sigsegv);
    longjmp(Main_loop_env, 0);
    return (signal_t) 0;
}

main(int argc, char *argv[])
{
    directory_entry room_info;
    char id_string[40];
    char message_base[80] = MESSAGEBASE;
    int ch, full = 0;
    extern char *optarg;

    setlinebuf(stdout);
    setlinebuf(stderr);
    while ((ch = getopt(argc, argv, "fM:t")) != EOF)
	switch (ch) {
	case 'f':
	  full = 1;
	  break;
	case 'M':
	  strcpy(message_base, optarg);
	  break;
	}

    if (chdir(message_base) != 0) {
	perror(message_base);
	return 1;
    }
    if (!database_init(TRUE, FALSE)) {
	perror("database init failed");
	return 1;
    }
    for (room = 0; room <= Last_rid; room++) {
	setjmp(Main_loop_env);
	signal(SIGSEGV, sigsegv);
	if (full) {
	  printf("%4d ", room);
	  fflush(stdout);
	}

	if (!get_directory_entry(&room_info, room))
	    continue;
	signal(SIGSEGV, SIG_DFL);
	sprintf(id_string, "<%s> (%d)",
		get_id(room_info.owner_uid),
		room_info.owner_uid);
	printf("%4d %-20s %-20s %-10s 0x%04x %d\n",
	       room,
	       room_info.name,
	       id_string,
	       classes[room_info.default_class],
	       room_info.groups,
	       room_info.room_offset);
    }
    database_shutdown();
    return 0;
}
