static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/changeclass.c,v 1.2 1993/08/13 03:14:16 kc Exp $");

#include "server.h"

void server_changeclass(int i)
{
  char id[ID_SIZE];
  class_t class;
  room_user_entry room_user_info;
  user_entry user_info;
  bb_uid uid;

  read_socket_s(Client[i].socket, id, sizeof(id));
  read_socket_int(Client[i].socket, (int *) &class);
  if(Client[i].rid == -1)
    SERVER_ERROR("no room selected");
  if(!MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  uid = get_uid(id);
  if(!get_user_entry(&user_info, uid))
    SERVER_ERROR("no such user");
  if(!get_room_user_entry(&room_user_info, Client[i].rid, uid)) {
    room_user_info.last_message_read = 0;
    room_user_info.user_offset = DEFAULT_USER_OFFSET;
  }
  room_user_info.class = class;
  if(!put_room_user_entry(Client[i].rid, uid, &room_user_info)) 
    SERVER_ERROR("error storing user information");
  if(class == no_class && !DAEMON(uid)) {
    directory_entry room_info;

    if(!get_directory_entry(&room_info, Client[i].rid))
      SERVER_ERROR("error accessing room information");
    class = room_info.default_class;
  }
  write_socket_code(Client[i].socket, SERVER_ACK);
}
