static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/create.c,v 1.2 1993/08/13 03:14:18 kc Exp $");

#include "server.h"

void server_create(int i)
{
    char room[ROOM_SIZE], summary[LINE_SIZE];
    bb_rid rid;
    char directory[LINE_SIZE];
    directory_entry room_info;

    read_socket_s(Client[i].socket, room, sizeof(room));
    read_socket_s(Client[i].socket, summary, sizeof(summary));
    if (DAEMON(Client[i].uid))
	SERVER_ERROR("permission denied");
    if (get_rid(room) != -1)
	SERVER_ERROR("room already exists");
    rid = add_rid(room);
    sprintf(directory, ACTIVE_ROOM, rid);
    if (mkdir(directory, 0777) != 0)
	SERVER_ERROR("filesystem error creating room");
    strcpy(room_info.name, room);
    room_info.next_message_number = 1;
    room_info.first_message_number = 1;
    room_info.creation_time = time(NULL);
    GROUP_ZERO(&room_info.groups);
    GROUP_SET(DEFAULT_GROUP, &room_info.groups);
    room_info.default_expiration = expiration_limit(room_info.groups);
    if (room_info.default_expiration > DEFAULT_EXPIRATION)
	room_info.default_expiration = DEFAULT_EXPIRATION;
    room_info.default_class = DEFAULT_ROOM_CLASS;
    room_info.owner_uid = Client[i].uid;
    room_info.room_offset = DEFAULT_ROOM_OFFSET;
    bcopy(summary, room_info.summary_line, sizeof(summary));
    room_info.archive = common_archive;
    if (!put_directory_entry(rid, &room_info))
	SERVER_ERROR("error storing room information");
    write_socket_code(Client[i].socket, SERVER_ACK);
}
