static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/group_change.c,v 1.2 1993/08/13 03:14:31 kc Exp $");

#include "server.h"

void server_groupchange(int i)
{
  char group[GROUP_SIZE];
  char new_owner[ID_SIZE];
  bb_gid gid;
  bb_uid new_owner_uid;
  group_entry group_info, new;

  read_socket_s(Client[i].socket, group, sizeof(group));
  read_socket_s(Client[i].socket, new.name, sizeof(new.name));
  read_socket_s(Client[i].socket, new_owner, sizeof(new_owner));
  read_socket_int(Client[i].socket, (int *) &new.default_class);
  read_socket_int(Client[i].socket, (int *) &new.group_offset);
  read_socket_int(Client[i].socket, (int *) &new.max_expiration);
  if((gid=get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if(!get_group_entry(&group_info, gid))
    SERVER_ERROR("error accessing group information");
  if(Client[i].uid != group_info.owner && !Client[i].owner)
    SERVER_ERROR("permission denied");

  if(*new.name) {
    if(get_gid(new.name) != -1)
      SERVER_ERROR("group already exists");
    put_gid(gid, new.name);
    remove_gid(group);
    strcpy(group_info.name, new.name);
  }
  if(*new_owner) {
    if((new_owner_uid=get_uid(new_owner))==-1)
      SERVER_ERROR("no such user");
    group_info.owner = new_owner_uid;
  }

  if(new.default_class != -1)
    group_info.default_class = new.default_class;

  if(new.group_offset && Client[i].owner) {
    /*
     * x > 0	set to (x - 1)
     * x == 0	don't change
     * x < 0	set to (x)
     */
    if(new.group_offset > 0) new.group_offset--;
    group_info.group_offset = new.group_offset;
  }

  if(new.max_expiration != -1 && Client[i].owner)
    group_info.max_expiration = new.max_expiration;

  if(!put_group_entry(gid, &group_info))
    SERVER_ERROR("error storing group information");

  write_socket_code(Client[i].socket, SERVER_ACK);
}
