static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/group_changeclass.c,v 1.2 1993/08/13 03:14:33 kc Exp $");

#include "server.h"

static char *classes[] =
{"no_access", "read_only", "read_write", "moderator", "no_class"};

void server_groupchangeclass(int i)
{
  char id[ID_SIZE];
  char group[GROUP_SIZE];
  class_t class;
  user_entry user_info;
  group_info *groupinfo;
  bb_uid uid;
  bb_gid gid;
  FILE *log;

  read_socket_s(Client[i].socket, group, sizeof(group));
  read_socket_s(Client[i].socket, id, sizeof(id));
  read_socket_int(Client[i].socket, (int *) &class);
  
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if((uid = get_uid(id))==-1)
    SERVER_ERROR("no such user");
  if(!(groupinfo = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(!MODERATOR_ACCESS(groupinfo->class) && !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(!get_user_entry(&user_info, uid))
    SERVER_ERROR("error accessing user information");
  user_info.group_class[gid] = class;
  if(!put_user_entry(uid, &user_info))
    SERVER_ERROR("error storing user information");
  update_cached_user_group_info(uid, gid);

  /* This assumes the server has chdir'ed to MESSAGEBASE */
  if (log = fopen("changeclass.log", "a")) {
    time_t t;

    t = time(NULL);
    fprintf(log, "%s changeclassed %s to %s in group %s, %s",
	    Client[i].id, id, classes[class], group, ctime(&t));
    fflush(log);
  } else {
    time_t t;
    t = time(NULL);
    syslog(LOG_ERR, "changeclass.log: %m");
    syslog(LOG_ERR, "%s changeclassed %s in group %s to class %s, %s",
	   Client[i].id, id, group, classes[class], ctime(&t));
  }
  write_socket_code(Client[i].socket, SERVER_ACK);
}
