static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/group_list.c,v 1.2 1993/08/13 03:14:40 kc Exp $");

#include "server.h"

void server_grouplist(int i)
{
  char group[GROUP_SIZE];
  bb_gid gid;
  group_info *groupinfo;
  user_entry user_info;
  bb_uid uid;
  char *id;
  bb_priority group_priority;
  class_t group_class;

  read_socket_s(Client[i].socket, group, sizeof(group));
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if(!(groupinfo = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(NO_ACCESS(groupinfo->class) && !Client[i].owner)
    SERVER_ERROR("permission denied");
  for(uid = 0; uid <= Last_uid; uid++) {
    if(uid == Client[i].uid) {
      id = Client[i].id;
      group_priority = Client[i].group_priority[gid];
      group_class = Client[i].group_class[gid];
    } else {
      if(!get_user_entry(&user_info, uid)) continue;
      /*
       * This is a vaguely silly place to put user expiration, but,
       * nevertheless, here it is.  I wanted it somewhere where it
       * isn't performed too often--yet, often enough.
       */
      if(Now - user_info.last_access_time > USER_EXPIRATION_PERIOD)
	remove_user(uid);
      id = user_info.id;
      group_priority = user_info.group_priority[gid];
      group_class = user_info.group_class[gid];
    }
    if(group_class != no_class) {
      write_socket_code(Client[i].socket, SERVER_ACK);
      write_socket_string(Client[i].socket, id);
      write_socket_int(Client[i].socket, group_priority);
      write_socket_int(Client[i].socket, group_class);
    }
  }
  write_socket_code(Client[i].socket, SERVER_EOF);
}
