static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/message_numbers.c,v 1.2 1993/08/13 03:15:07 kc Exp $");

#include "server.h"
#include <sys/errno.h>

void server_message_numbers(int i)
{
    summary_entry *message;
    message_entry *message_info;
    summary_list *summary;
    int rid;
    int start_range = -1, end_range = -1;

    read_socket_int(Client[i].socket, &rid);
    if (Client[i].rid == -1)
	SERVER_ERROR("no room selected");
    if (DAEMON(Client[i].uid))
	SERVER_ERROR("permission denied");
    /* expire_messages(Client[i].rid); */
    if (!(summary = get_summary(Client[i].rid)))
	SERVER_ERROR("error accessing room summary");
    if (Client[i].update_message_numbers == summary->version) {
	write_socket_code(Client[i].socket, SERVER_NAK);
	return;
    }
    for (message = summary->list;
	 message < summary->list + summary->count;
	 message++) {
	message_info = &(message->header);
	if (!message_info->deleted) {
	    if(start_range == -1) {
		start_range = message->number;
	    } else if(message->number - end_range > 1) {
		if (start_range == end_range) {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
		    write_socket_int(Client[i].socket, start_range);
		} else {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
		    write_socket_int(Client[i].socket, start_range);
		    write_socket_int(Client[i].socket, end_range);
		}
		start_range = message->number;
	    }
	    end_range = message->number;
	} else {
	    if (start_range != -1) {
		if (start_range == end_range) {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
		    write_socket_int(Client[i].socket, start_range);
		} else {
		    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
		    write_socket_int(Client[i].socket, start_range);
		    write_socket_int(Client[i].socket, end_range);
		}
		start_range = -1;
	    }
	}
    }
    if (start_range != -1) {
	if (start_range == end_range) {
	    write_socket_code(Client[i].socket, SERVER_MESSAGE_SINGLE);
	    write_socket_int(Client[i].socket, start_range);
	} else {
	    write_socket_code(Client[i].socket, SERVER_MESSAGE_RANGE);
	    write_socket_int(Client[i].socket, start_range);
	    write_socket_int(Client[i].socket, end_range);
	}
	start_range = -1;
    }
    write_socket_code(Client[i].socket, SERVER_EOF);
    Client[i].update_message_numbers = summary->version;
}
