static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/post.c,v 1.2 1993/08/13 03:15:14 kc Exp $");

#include "server.h"
#include <sys/file.h>

void server_post(int i)
{
  directory_entry room_info;
  FILE *write_file;
  char filename[BUFFER_SIZE];
  char *buf, *c;
  message_entry message;
  int number;

  if(Read_only)
    SERVER_ERROR("Messagebase is readonly.");
  if(Client[i].rid == -1)
    SERVER_ERROR("no room selected");
  if(!WRITE_ACCESS(get_class(i, Client[i].rid)))
    SERVER_ERROR("permission denied");
  if(!get_directory_entry(&room_info, Client[i].rid))
    SERVER_ERROR("error accessing room information");
  number = room_info.next_message_number++;
  sprintf(filename, ACTIVE_MESSAGE, Client[i].rid, number);
  write_file = fopen(filename, "w+");
  if(!write_file) {
    syslog(LOG_DEBUG, "posting %s: %m", filename);
    SERVER_ERROR("error opening output file");
  }
  message.date = time(0);
  message.expiration = message.date + room_info.default_expiration;
  message.deleted = FALSE;
  message.poster_uid = Client[i].uid;
  bcopy(Client[i].id, message.poster_id, ID_SIZE);
  bcopy(Client[i].nick, message.poster_nick, LINE_SIZE);
  write_socket_code(Client[i].socket, SERVER_ACK);
  read_socket_s(Client[i].socket, message.subject, sizeof(message.subject));
  message.size = read_socket_buf(Client[i].socket, &buf);
  fwrite(buf, message.size, 1, write_file);
  fclose(write_file);
  message.lines = 0;
  for(c=buf; c<buf+message.size; c++) if(*c == '\n') message.lines++;
  if(*(--c) != '\n') message.lines++;
  free(buf);
  if(!put_message_entry(Client[i].rid, number, &message))
    SERVER_ERROR("error storing message information");
  if(!put_directory_entry(Client[i].rid, &room_info))
    SERVER_ERROR("error storing room information");
  write_socket_code(Client[i].socket, SERVER_ACK);
  Client[i].posts++;
}
