static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/preserve.c,v 1.4 1993/08/13 03:15:16 kc Exp $");

#include "server.h"

void server_preserve(int i)
{
  int message;
  time_t new_expiration;
  message_entry message_info;
  directory_entry room_info;

  read_socket_int(Client[i].socket, &message);
  read_socket_int(Client[i].socket, (int *) &new_expiration);

  if(!db_get_message_entry(&message_info, Client[i].rid, message))
    SERVER_ERROR("no such message");
  if(!MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(!get_directory_entry(&room_info, Client[i].rid))
    SERVER_ERROR("error accessing room information");
  if(new_expiration > expiration_limit(room_info.groups) && !Client[i].owner)
    SERVER_ERROR("expiration period too long");
  if(new_expiration < MIN_EXPIRATION && !Client[i].owner)
    SERVER_ERROR("expiration period too short");
  message_info.expiration = Now + new_expiration;
  if(!put_message_entry(Client[i].rid, message, &message_info))
    SERVER_ERROR("error storing message information");
  write_socket_code(Client[i].socket, SERVER_ACK);
}
