static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/read.c,v 1.3 1993/08/13 03:15:22 kc Exp $");

#include "server.h"
#include <sys/errno.h>
#include <sys/stat.h>
#include <fcntl.h>

void server_read(int i)
{
  int read_file;
  int message;
  struct stat filestat;
  char *buf;
  char filename[BUFFER_SIZE];
  message_entry message_info;
  int l;

  read_socket_int(Client[i].socket, &message);
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if(!db_get_message_entry(&message_info, Client[i].rid, message)) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  if(message_info.deleted) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  sprintf(filename, ACTIVE_MESSAGE, Client[i].rid, message);
  read_file=open(filename, O_RDONLY);
  if(read_file == -1) {
    if(errno != ENOENT)
      SERVER_ERROR(sys_errlist[errno]);
    /* message file not found:  remove message entry */
    remove_message_entry(Client[i].rid, message);
    write_socket_code(Client[i].socket, SERVER_NAK);
    return;
  }
  if(fstat(read_file, &filestat)!=0) {
    write_socket_code(Client[i].socket, SERVER_NAK);
    close(read_file);
    return;
  }
  buf = (char *) malloc(MAX(filestat.st_size, 1));
  l = read(read_file, buf, filestat.st_size);
  close(read_file);
  if(l!=filestat.st_size) {
    syslog(LOG_DEBUG, "reading %s: %m", filename);
    write_socket_code(Client[i].socket, SERVER_NAK);
    free(buf);
    return;
  }
  write_socket_code(Client[i].socket, SERVER_ACK);
  write_socket_int(Client[i].socket, message);
  write_socket_int(Client[i].socket, message_info.date);
  write_socket_int(Client[i].socket, message_info.expiration);
  write_socket_int(Client[i].socket, message_info.lines);
  write_socket_string(Client[i].socket, message_info.poster_id);
  write_socket_string(Client[i].socket, get_id(message_info.poster_uid));
  write_socket_string(Client[i].socket, message_info.poster_nick);
  write_socket_string(Client[i].socket, message_info.subject);
  write_socket(Client[i].socket, buf, l);
  free(buf);
  if(message > Client[i].last_message_read)
    update_room_pointer(i, Client[i].rid, message);
}
