static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/search.c,v 1.2 1993/08/13 03:15:34 kc Exp $");

#include "server.h"
#include <sys/errno.h>
#include <sys/stat.h>
#include <fcntl.h>

void server_search(int i)
{
  int read_file, l, size = -1;
  bb_rid rid;
  struct stat filestat;
  char room[ROOM_SIZE], regexp[BUFFER_SIZE], *buf, filename[BUFFER_SIZE];
  summary_entry *message;
  message_entry *message_info;
  summary_list *summary;

  read_socket_s(Client[i].socket, room, sizeof(room));
  read_socket_s(Client[i].socket, regexp, sizeof(regexp));
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if((rid=get_rid(room)) == -1)
    SERVER_ERROR("no such room");
  if(buf = (char *) re_comp(regexp))
    SERVER_ERROR(buf);
  if(!(summary = get_summary(rid)))
    SERVER_ERROR("error accessing room summary");
  for(message = summary->list;
      message < summary->list + summary->count;
      message++) {
    message_info = &(message->header);
    if(message_info->deleted) continue;
    sprintf(filename, ACTIVE_MESSAGE, rid, message->number);
    if((read_file=open(filename, O_RDONLY)) == -1) continue;
    if(fstat(read_file, &filestat) != 0 || !filestat.st_size) {
      close(read_file);
      continue;
    }
    if(size == -1) {
      size = filestat.st_size+1;
      buf = (char *) malloc(size);
    } else if(size < filestat.st_size) {
      size = filestat.st_size+1;
      buf = (char *) realloc(buf, size);
    }
    l = read(read_file, buf, filestat.st_size);
    close(read_file);
    if(l!=filestat.st_size) continue;
    *(buf+l) = '\0';
    if(re_exec(buf)!=1) continue;
    write_socket_code(Client[i].socket, SERVER_ACK);
    write_socket_int(Client[i].socket, message->number);
  }
  if(size != -1) free(buf);
  write_socket_code(Client[i].socket, SERVER_EOF);
}
