static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/select.c,v 1.2 1993/08/13 03:15:37 kc Exp $");

#include "server.h"

void server_select(int i)
{
    char room[ROOM_SIZE];
    directory_entry room_info;
    bb_rid rid = -1, old_rid = Client[i].rid;

    read_socket_s(Client[i].socket, room, sizeof(room));
    if (*room) {
	if ((rid = get_rid(room)) == -1)
	    SERVER_ERROR("no such room");
	if (!get_directory_entry(&room_info, rid))
	    SERVER_ERROR("error accessing room information");
    }
    if (!Read_only && !save_room_pointer(i))
	SERVER_ERROR(error_text);
    if (!*room) {
	Client[i].rid = -1;
	write_socket_code(Client[i].socket, SERVER_ACK);
	write_socket_int(Client[i].socket, 0);
	if (Client[i].minor_version >= 4) {
	    write_socket_int(Client[i].socket, Client[i].rid);
	}
    } else {
	room_user_entry room_user_info;

	Client[i].rid = rid;
	if (!get_room_user_entry(&room_user_info, rid, Client[i].uid)) {
	    Client[i].last_message_read = room_info.first_message_number - 1;
	} else {
	    Client[i].last_message_read = MAX(room_info.first_message_number - 1,
					  room_user_info.last_message_read);
	}
	if (!Client[i].owner && !READ_ACCESS(get_class(i, rid))) {
	    Client[i].rid = -1;
	    SERVER_ERROR("access denied");
	}
	Client[i].update_summary = -1;
	Client[i].update_message_numbers = -1;
	write_socket_code(Client[i].socket, SERVER_ACK);
	write_socket_int(Client[i].socket, Client[i].last_message_read);
	if (Client[i].minor_version >= 4) {
	    write_socket_int(Client[i].socket, Client[i].rid);
	}
    }
    if (old_rid != -1)
	expire_room(old_rid);
}
