static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/signon.c,v 1.2 1993/08/13 03:15:49 kc Exp $");

#include "server.h"
#include "../lib/misc.h"

void server_signon(int i)
{
    user_entry userinfo;
    char passwd[10];
    boolean create_flag;
    bb_gid gid;
    bb_rid rid;

    read_socket_s(Client[i].socket, Client[i].user, sizeof(Client[i].user));
    read_socket_s(Client[i].socket, Client[i].id, sizeof(Client[i].id));
    Client[i].uid = get_uid(Client[i].id);
    read_socket_s(Client[i].socket, passwd, sizeof(passwd));
    read_socket(Client[i].socket, &create_flag, sizeof(create_flag));
    if (Client[i].uid == -1 || !get_user_entry(&userinfo, Client[i].uid)) {
	char saltc[2];
	time_t salt;
	int c, j;

	if (!create_flag)
	    SERVER_ERROR("no signon exists under that id");

    /* new user:  use default values */
	Client[i].uid = add_uid(Client[i].id);
	bzero((char *)&userinfo, sizeof(userinfo));
	strcpy(userinfo.id, Client[i].id);
	time(&salt);
	saltc[0] = salt & 077;
	saltc[1] = (salt >> 6) & 077;
	for (j = 0; j < 2; j++) {
	    c = saltc[j] + '.';
	    if (c > '9')
		c += 7;
	    if (c > 'Z')
		c += 6;
	    saltc[j] = c;
	}
	strcpy(userinfo.passwd, (char *)crypt(passwd, saltc));
	userinfo.uses = 0;
	userinfo.posts = 0;
	userinfo.connect_time = 0;
	userinfo.cutoff_priority = DEFAULT_CUTOFF_PRIORITY;
	for (gid = 0; gid < MAX_GROUPS; gid++) {
	    userinfo.group_priority[gid] = 0;
	    userinfo.group_class[gid] = no_class;
	}
    } else {
	if (create_flag)
	    SERVER_ERROR("that id is already in use");
    }
    if (strcmp((char *)crypt(passwd, userinfo.passwd), userinfo.passwd) != 0)
	SERVER_ERROR("incorrect password");
    userinfo.uses++;
    userinfo.last_access_time = time(0);
    sprintf(userinfo.last_access_source, "%s@%s",
	    Client[i].user, Client[i].host);

    if (!Read_only && !put_user_entry(Client[i].uid, &userinfo))
	SERVER_ERROR("error storing user information");
    write_socket_code(Client[i].socket, SERVER_ACK);
    write_socket_int(Client[i].socket, userinfo.cutoff_priority);

    strcpy(Client[i].address, userinfo.last_access_source);
    strcpy(Client[i].nick, userinfo.nick);
    Client[i].signon_time = userinfo.last_access_time;
    Client[i].cutoff_priority = userinfo.cutoff_priority;
    Client[i].signed_on = TRUE;
    Client[i].posts = 0;
    Client[i].owner = OWNER(Client[i].uid);
    Client[i].update_directory = 0;
    Client[i].update_summary = -1;
    Client[i].update_message_numbers = -1;
    Client[i].rid = -1;
    Client[i].dir_info = (Last_rid >= 0) ?
      (directory_info **) malloc((Last_rid + 1) * sizeof(directory_info *)) :
      NULL;
    Client[i].stamp = (Last_rid >= 0) ? (struct client_stamp *)
      malloc((Last_rid + 1) * sizeof(struct client_stamp)) : NULL;
    for (rid = 0; rid <= Last_rid; rid++) {
	Client[i].dir_info[rid] = NULL;
	Client[i].stamp[rid].update = 1;
	Client[i].stamp[rid].sent = 0;
    }
    for (gid = 0; gid <= Last_gid; gid++) {
	group_entry group_info;

	Client[i].group_priority[gid] = userinfo.group_priority[gid];
	if (get_group_entry(&group_info, gid))
	    Client[i].group_priority[gid] += group_info.group_offset;
	Client[i].group_class[gid] = userinfo.group_class[gid];
    }
}
