static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/summary.c,v 1.2 1993/08/13 03:15:54 kc Exp $");

#include "server.h"
#include <sys/errno.h>

void server_summary(int i)
{
    summary_entry *message;
    message_entry *message_info;
    summary_list *summary;

    if (Client[i].rid == -1)
	SERVER_ERROR("no room selected");
    if (DAEMON(Client[i].uid))
	SERVER_ERROR("permission denied");
    expire_messages(Client[i].rid);
    if (!(summary = get_summary(Client[i].rid)))
	SERVER_ERROR("error accessing room summary");
    if (Client[i].update_summary == summary->version) {
	write_socket_code(Client[i].socket, SERVER_NAK);
	return;
    }
    for (message = summary->list;
	 message < summary->list + summary->count;
	 message++) {
	message_info = &(message->header);
	if (!message_info->deleted) {
	    write_socket_code(Client[i].socket, SERVER_ACK);
	    write_socket_int(Client[i].socket, message->number);
	    write_socket_int(Client[i].socket, message_info->date);
	    write_socket_int(Client[i].socket, message_info->lines);
	    write_socket_string(Client[i].socket, message_info->poster_id);
	    write_socket_string(Client[i].socket,
				get_id(message_info->poster_uid));
	    write_socket_string(Client[i].socket, message_info->poster_nick);
	    write_socket_string(Client[i].socket, message_info->subject);
	    write_socket_int(Client[i].socket, message_info->expiration);
	}
    }
    write_socket_code(Client[i].socket, SERVER_EOF);
    Client[i].update_summary = summary->version;
}
