static void *rcs_id = (rcs_id, "$Header: /LocalDeveloper/Source/CVS/OmniGroup/bb/server/undelete.c,v 1.3 1993/08/13 03:15:56 kc Exp $");

#include "server.h"

void server_undelete(int i)
{
  int message;
  message_entry message_info;
  directory_entry room_info;

  read_socket_int(Client[i].socket, &message);
  if(DAEMON(Client[i].uid))
    SERVER_ERROR("permission denied");
  if(!db_get_message_entry(&message_info, Client[i].rid, message))
    SERVER_ERROR("no such message");
  if(Client[i].uid != message_info.poster_uid &&
     !MODERATOR_ACCESS(get_class(i, Client[i].rid)) &&
     !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(Client[i].uid != message_info.poster_uid) {
    char subject[LINE_SIZE];
    FILE *message_f;
    const char *room = get_roomname(Client[i].rid);

    sprintf(subject, "%s #%d undeleted by <%s>",
	    room, message, Client[i].id);
    if(message_f = mail(Client[i].uid, message_info.poster_uid, subject)) {
      fprintf(message_f,
	      "Your posting #%d in room %s was undeleted by <%s> (%d)\n",
	      message, room, Client[i].id, Client[i].uid);
      pclose(message_f);
    }
  }
  message_info.deleted = 0;
  if(!put_message_entry(Client[i].rid, message, &message_info)) 
    SERVER_ERROR("database error undeleting message");
  if(!get_directory_entry(&room_info, Client[i].rid))
    SERVER_ERROR("error accessing room information");
  if(!put_directory_entry(Client[i].rid, &room_info))
    SERVER_ERROR("error storing room information");
  write_socket_code(Client[i].socket, SERVER_ACK);
  return;
}
